<?PHP
/*
Plugin Name: Auto Post Images (API)
Plugin URI: http://karthikeyan.karunanidhi.com/
Version: v1.00
Author: <a href="http://karthikeyan.karunanidhi.com/">Karthikeyan Karunanidhi</a>
Description: This plugin will automatically put images into each post. All you have to do is upload the image into the '/wp-content/plugins/auto-post-images/images/' directory and name them as 'Image_POSTID[_SUFFIX].jpg' where 'POSTID' is ID of post and if you have more than one image then you can add any prefix after the 'POSTID' separated by an underscore. Posts that do not have image will show a default image. Example Image Name: Image_66.jpg, Image_66_a.jpg, Image_66_two.gif, etc.

Copyright Karthikeyan Karunanidhi (email : wordpress [a t ] karunanidhi DOT com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

	if (!class_exists("KKAutoPostImages")) {

		require_once (dirname(__FILE__) . '/php/Filesystem.class.php');

		class KKAutoPostImages {

			var $iPostId = 0;
			var $sImageDirPath = '';
			var $sImageDirUrl = '';
			var $sDefaultImageUrl = '';

			function KKAutoPostImages () {

			}

			function showImagesByPostId ($sContent) {

				if(is_page()) {

					return $sContent;
				}

				global $post;
				$this->iPostId = $post->ID;
				$sHtml = '';

				if( $this->iPostId == FALSE || !is_numeric($this->iPostId) ) {

					$this->iPostId = 0;
				}

				$this->sImageDirPath = dirname(__FILE__) . '/images/';
				$this->sImageDirUrl = get_bloginfo('wpurl') . '/wp-content/plugins/auto-post-images/images/';
				$this->sDefaultImageUrl = $this->sImageDirUrl . 'imagecomingsoon.jpg';

				$aImageFiles = $this->getImagesForThisPost($this->iPostId);

				foreach($aImageFiles as $key => $sImagePath) {

					$sImageDirPath = $this->sImageDirPath . $sImagePath;

					if( !is_file($sImageDirPath) ) {

						unset($aImageFiles[$key]);
					}

					$aImageFiles[$key] = $this->sImageDirUrl . $sImagePath;
				}

				if( empty($aImageFiles) ) {

					$aImageFiles[] = $this->sDefaultImageUrl;
				}

				$sHtml .= '<div class="kkautopostimage">';

				foreach($aImageFiles as $key => $sImagePath) {

					$sHtml .= "<img src=\"{$sImagePath}\" alt=\"Image\" title=\"Image\" /><br />";
				}

				$sHtml .= '</div>';

				return $sHtml . $sContent;
			}

			function includeCSS () {

				echo '<link type="text/css" rel="stylesheet" href="' . get_bloginfo('wpurl') . '/wp-content/plugins/auto-post-images/css/kkimageinpost.css" />' . "\n";
			}

			function getImagesForThisPost($iPostId) {

				$oFileSys = new Filesystem();
				$sPattern = "^Image_{$iPostId}[_0-9]*\.[a-zA-Z]+$";
				$aImages = $oFileSys->readDir($this->sImageDirPath, $sPattern);

				return $aImages;
			}

		}

	} //End Class KKAutoPostImages

	if (class_exists("KKAutoPostImages")) {

		$kk_autopostimages = new KKAutoPostImages();
	}

	// Actions and Filters
	//
	if (isset($kk_autopostimages)) {

		// Actions
		add_action('wp_head', array(&$kk_autopostimages, 'includeCSS'), 1);

		// Filters
		//
		add_filter('the_content', array(&$kk_autopostimages, 'showImagesByPostId'));
	}

?>